#include <bits/stdc++.h>
using namespace std;

int n, m;
vector<pair<int,int>> a;
vector<int> p;

int par(int x) {
    if (p[x] == x || p[x] == -1) {
        return p[x] = x;
    }
    else return p[x] = par(p[x]);
}

void unit(int u, int v) {
    u = par(u);
    v = par(v);
    p[u] = v;
}

int checkedges(vector<int> v) {
    for (int i = 0; i <= n; i++) p[i] = i;
    for (auto j : v) {
        if (par(a[j].first)==par(a[j].second)) return 0;
        else unit(a[j].first,a[j].second);
    }
    return 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m;
    a.resize(m);
    for (int i = 0; i < m; i++) cin >> a[i].first >> a[i].second;
    vector<int> dp(m+1);
    p.resize(n+1);
    dp[0] = 0;
    for (int i = 1; i <= m; i++) {
        for (int j = 0; j <= n; j++) p[j] = j;
        int j = i;
        for (; j > 0; j--) {
            if (par(a[j-1].first)==par(a[j-1].second)) break;
            else unit(a[j-1].first,a[j-1].second);
        }
        dp[i] = min(dp[j],dp[i-1])+1;
        //cout << dp[i] << endl;
    }
    cout << dp[m];
}
