#include <bits/stdc++.h>
using namespace std;
using pii = pair<int, int>;
const int msz = 1e6 + 5;

struct dsu{
    vector<int> sz, op, p;
    int n;
    void init(int ns){
        n = ns;
        op.resize(n + 1);
        p.resize(n + 1);
        sz.resize(n + 1);
        for (int i = 1; i <= n; i++){
            p[i] = i;
            sz[i] = 1;
            op[i] = 0;
        }
    }
    int get(int v){
        if (p[v] != v){
            p[v] = get(p[v]);
        }
        return p[v];
    }
    void unite(int x, int y){
        x = get(x); y = get(y);
        if (x == y) return;
        if (sz[x] > sz[y]) swap(x, y);
        p[x] = y;
        sz[y] += sz[x];
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m; cin>>n>>m;
    vector<pii> edges(m + 1);
    for (int i = 1; i <= m; i++){
        cin>>edges[i].first>>edges[i].second;
    }
    int out = 1;
    dsu T; T.init(n);
    vector<int> all;
    for (int i = 1; i <= m; i++){
        auto [u, v] = edges[i];
        all.push_back(u);
        all.push_back(v);
        u = T.get(u); v = T.get(v);
        if (u == v){
            out++;
            for (int j: all){
                T.p[j] = j;
                T.sz[j] = 1;
                T.op[j] = 0;
            }
            all.clear();
            i--;
            continue;
        }
        if (!T.op[u] && !T.op[v]){
            T.op[u] = v;
            T.op[v] = u;
            continue;
        }
        if (!T.op[u]){
            T.op[u] = v;
            T.unite(u, T.op[v]);
            continue;
        }
        if (!T.op[v]){
            T.op[v] = u;
            T.unite(v, T.op[u]);
            continue;
        }
        T.unite(u, T.op[v]);
        T.unite(v, T.op[u]);
        // додати ребро
        // перевірити чи біпартивний
        // якщо ні, то очистити і почати з 'i'
    }
    cout<<out;
}