#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, k;
	cin >> n >> k;
	vector<pair<long double, int>> ps(n);
	vector<int> r(n), t(n);
	for (int i = 0; i < n; i++) {
		cin >> r[i] >> t[i];
		ps[i] = { (ld)r[i] / (ld)t[i], i };
	}
	sort(ps.rbegin(), ps.rend());
	ld R = 0, T = 0;
	for (int i = 0; i < k; i++) {
		int j = ps[i].second;
		R += r[j];
		T += t[j];
	}
	cout << fixed << setprecision(9) << R / T << "\n";
}