#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, k;
	cin >> n >> k;
	vector<int> r(n), t(n);
	for (int i = 0; i < n; i++)
		cin >> r[i];
	for (int i = 0; i < n; i++)
		cin >> t[i];

	ld L = 0, R = 100001;
	while (L + 1e-6 < R) {
		ld m = (L + R) / 2;
		ld ch = 0;
		vector<ld> psn(n);
		for (int i = 0; i < n; i++)
			psn[i] = (ld)r[i] - (ld)t[i] * m;
		sort(psn.rbegin(), psn.rend());
		for (int i = 0; i < k; i++)
			ch += psn[i];
		if (ch >= -1e-6)
			L = m;
		else
			R = m;
	}
	cout << fixed << setprecision(10) << L << "\n";
}