F = list(map(list, [input() for _ in range(6)]))

A = F[:3]
B = F[3:]

def subMatix(A, B):
    def subList(A, B):
        acc = [0, 0, 0]
        for i in range(len(A)):
            acc[i] = B[i] - A[i]
        return acc

    acc = [ [], [], [] ]
    for i in range(len(A)):
        acc[i] = subList(A[i], B[i])
    return acc

def toBitmap(kernel: dict[str, int], A: list[list]) -> list[list[int]]:
    bitmap = A
    for i in range(len(bitmap)):
        for j in range(len(bitmap[i])):
            A[i][j] = kernel[A[i][j]]
    return A

def possibleMove(A, B):
    turn = "X" if sum(A, []).count("X") == sum(A, []).count("0") else "O"

    kernel = { ".": 0, "X": 1, "0": -1}
    A_m, B_m = toBitmap(kernel, A), toBitmap(kernel, B)
    diff = subMatix(A_m, B_m)
    
    # print("A", A)
    # print("B", B)
    # print(diff)

    # print(
    #     "Moves made by",
    #     {
    #         "X": sum(diff, []).count(1),
    #         "O": sum(diff, []).count(-1)
    #     }
    # )
    
    if turn == "X":
        return sum(diff, []).count(-1) == 0
    else:
        return sum(diff, []).count(1) == 0

print("YES" if possibleMove(A, B) else "NO")