from itertools import permutations

_, count = map(int, input().split(' '))
ratings = map(int, input().split(' '))
times = map(int, input().split(' '))

items = list(zip(ratings, times))

def heuristic(playlist):
    ratings, times = *playlist,
    try:
        return sum(ratings) / sum(times)
    except ZeroDivisionError:
        return -1

print(
    sorted(
        map(heuristic, permutations(items, count)),
    reverse=True)[0]
)