from itertools import combinations
import sys

_, count = map(int, input().split(' '))
ratings = list(map(int, input().split(' ')))
times = list(map(int, input().split(' ')))

items = list(zip(ratings, times))

def heuristic(playlist: list[tuple[int, int]]) -> float:
    ratings, times = zip(*playlist)
    return sum(ratings) / sum(times)

# If I could implement interactive deepening with alpha-beta pruning....
print(
    sorted(
        map(heuristic,
            combinations(items, count)
        )
    , reverse=True)[0]
)