field_before = [input() for _ in range(3)]
field_after = [input() for _ in range(3)]

zero_count_before = sum(line.count("0") for line in field_before)
cross_count_before = sum(line.count("X") for line in field_before)
zero_count_after = sum(line.count("0") for line in field_after)
cross_count_after = sum(line.count("X") for line in field_after)

fields_equal = all(line1 == line2 for line1, line2 in zip(field_before, field_after))

is_legal_move = (
    cross_count_after == cross_count_before + 1 and zero_count_after == zero_count_before
    if zero_count_before == cross_count_before
    else cross_count_after == zero_count_after and cross_count_after == cross_count_before
)

changes_count = 0

for i in range(3):
    for j in range(3):
        if field_before[i][j] != field_after[i][j]:
            changes_count += 1

            if changes_count >= 2:
                break

    if changes_count >= 2:
        break

answer = fields_equal or (is_legal_move and changes_count == 1)

print("YES" if answer else "NO")
