#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;

bool comp(pair<ld, ll> a, pair<ld, ll> b) {
    ld ac = a.first * 1.0l / a.second;
    ld bc = b.first * 1.0l / b.second;
    if (ac < bc) return false;
    if (bc < ac) return true;
    return a.second > b.second;
}

void solve() {
    ll n, k; cin >> n >> k;
    vector<ll> a(n), b(n);
    vector<pair<ld,ll>> best(n);
    for (ll i = 0; i < n; i++) cin >> a[i];
    for (ll i = 0; i < n; i++) {
        cin >> b[i];
        best[i] = { a[i], b[i] };
    }
    sort(best.begin(), best.end(), comp);
    ld ans = 0;
    ld f = 0, s = 0;
    for (ll i = 0; i < k; i++) {
        f += best[i].first;
        s += best[i].second;
    }
    ans = f / s;
    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
}
