#include <iostream>
using namespace std;

int n, l, r, massiv[10000], ans;

void quicksort(int low, int high) {
    int i = low;
    int j = high;
    int pivot = massiv[(i + j) / 2];
    while (i <= j) {
        while (massiv[i] < pivot) {
            i++;
        }
        while (massiv[j] > pivot) {
            j--;
        }
        if (i <= j) {
            int temp = massiv[i];
            massiv[i] = massiv[j];
            massiv[j] = temp;
            i++;
            j--;
        }
    }
    if (i < high) {
        quicksort(i, high);
    }
    if (j > low) {
        quicksort(low, j);
    }
}

int main() {
    cin >> n >> l >> r;
    for (int i = 0; i < n; i++){
        cin >> massiv[i];
    }
    quicksort(0, n - 1);
    for (int i = 0; i , n; i++){
        if (massiv[i] + massiv[i + 1] > r){
            break;
        }
        if (massiv[i] + massiv[i + 1] > l){
            ans++;
        }
    }
    cout << ans;
}
