#include <bits/stdc++.h>
using namespace std;
using ll = long long;

ll n, m, q, k, a, b, c, x, y, l, r;

ll par[1000000];
ll sz[1000000];
ll color[1000000];
vector<ll> st[1000000];
set<ll> all_used;

void clear() {
    for (int i : all_used) {
        par[i] = i;
        sz[i] = 1;
        color[i] = 0;
        st[i].clear();
        st[i].push_back(i);
    }
    all_used.clear();
}

ll find_p(ll x) {
    if (par[x] == x) {
        return x;
    }
    ll p = find_p(par[x]);
    par[x] = p;
    return p;
}

bool join(ll x, ll y) {
    all_used.insert(x);
    all_used.insert(y);
    bool fl = 0;
    if (color[x] == color[y]) {
        fl = 1;
    }
    // cout << '\t' << x << ' ' << y << ' ' << fl << endl;
    x = find_p(x);
    y = find_p(y);
    if (x == y) {
        return !fl;
    }
    // cout << '\t' << sz[x] << ' ' << sz[y] << '\n';
    if (sz[x] < sz[y]) {
        swap(x, y);
    }
    sz[x] += sz[y];
    par[y] = x;
    if (fl) {
        for (int i : st[y]) {
            color[i] = 1 - color[i];
        }
    }
    for (int i : st[y]) {
        st[x].push_back(i);
    }
    st[y].clear();
    return 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout<<fixed;
    cout<<setprecision(6);

    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        par[i] = i;
        sz[i] = 1;
        color[i] = 0;
        st[i].clear();
        st[i].push_back(i);
    }
    vector< pair<ll, ll> > v(m);
    // dsu f;
    ll ans = 1;
    // cout << ans << endl;
    for (int i = 0; i < m; i++) {
        cin >> v[i].first >> v[i].second;
        v[i].first--;
        v[i].second--;
        // cout << "DEBUG" << endl;
        if (!join(v[i].first, v[i].second)) {
            // cout << "\tDEBUG" << endl;
            clear();
            // cout << "\tDEBUG" << endl;
            // f = dsu();
            // cout << "\tDEBUG" << endl;
            join(v[i].first, v[i].second);
            ans++;
        }
        // cout << i << endl;
        // for (auto i : f.color) {
        //     cout << i.first << ' ' << i.second << '\n';
        // }
        // cout << endl;
    }
    // f.clear();
    cout << ans << endl;
}