#include <bits/stdc++.h>
using namespace std;

class track {
    public: 
    int rating;
    int timing;
    int efficiency;
    void count() {
        efficiency = rating*1.0/timing;
    }
};

int all, goal;
vector<track> tracks = {};
vector<track> chosen = {};
int chosen_amount = 0;
int current_rating_sum = 0;
int current_timing_sum = 0;

float check_efficiency(int index) {
    return (current_rating_sum+tracks[index].rating)*1.0/(current_timing_sum+tracks[index].timing);
}

bool efficiency_sort(track first, track second) {
    if (first.efficiency==second.efficiency) {
        return(first.timing<second.timing);
    }
    else return(first.efficiency>second.efficiency);
}

int main() {
    cin >> all >> goal;
    string buf;
    chosen.resize(goal);
    for (int i = 0; i < all; i++) {
        cin >> buf;
        tracks.push_back(track()); 
        tracks[i].rating = stoi(buf);   
    }
    for (int i = 0; i < all; i++) {
        cin >> buf;
        tracks[i].timing = stoi(buf);   
        tracks[i].count();
    }
    sort(tracks.begin(), tracks.end(), efficiency_sort);
    while (chosen_amount!=goal) {
        int best_choice_id = 0;
        float best_efficiency = 0;
        for (int i = 0; i < tracks.size(); i++) {
            float efficiency = check_efficiency(i);
            if (efficiency > best_efficiency) {
                best_efficiency = efficiency;
                best_choice_id = i;
            }
        }
        current_rating_sum += tracks[best_choice_id].rating;
        current_timing_sum += tracks[best_choice_id].timing;
        chosen[chosen_amount] = tracks[best_choice_id];
        tracks.erase(tracks.begin()+best_choice_id);
        chosen_amount++;
    }
    cout << current_rating_sum*1.0/current_timing_sum << endl;
}
