#include <vector>
#include <iostream>
#include <algorithm>
#include <cmath>

using namespace std;


int vecSum(vector<double> vec) {
	int result = 0;
	for (const auto& x : vec)
		result += x;
	return result;
}

vector<pair<double, int>> songsToRatio(vector<vector<double>> songs) {
	vector<pair<double, int>> result;
	for (int i = 0; i < songs[0].size(); i++)
	{
		double temp = songs[0][i] / songs[1][i];
		result.push_back(pair<double, int>(temp, i));
	}
	return result;
}


int main()
{
	int nSongs, nReqSongs;
	cin >> nSongs >> nReqSongs;
	vector<vector<double>> songs;

	for (int i = 0; i < 2; i++)
	{
		vector<double> temp;
		for (int i = 0; i < nSongs; i++)
		{
			double tempInt;
			cin >> tempInt;
			temp.push_back(tempInt);
		}
		songs.push_back(temp);
	}

	double raitingSum = vecSum(songs[0]);
	double durSum = vecSum(songs[1]);

	/*if (nSongs == nReqSongs) {
		cout << double(raitingSum / durSum);
		return 0;
	}*/
		

	vector<pair<double, int>> songsRatio = songsToRatio(songs);
	sort(songsRatio.rbegin(), songsRatio.rend());

	double resultRaiting = 0;
	double resultDuration = 0;

	for (int i = 0; i < nReqSongs; i++)
	{
		resultRaiting += songs[0][songsRatio[i].second];
		resultDuration += songs[1][songsRatio[i].second];
	}

	double result = resultRaiting / resultDuration;
	

	cout << round(result*10000)/10000;
}
