#include <bits/stdc++.h>
using namespace std;
using ll = long long;

struct ST{
    vector<int> t;
    int n;
    ST(int ns){
        n = ns;
        t.resize(4 * n);
    }
    void upd(int v, int tl, int tr, int& pos, int& val){
        if (tl == tr){
            t[v] = val;
            return;
        }
        int tm = (tl + tr) / 2, vv = 2 * v;
        if (pos <= tm){
            upd(vv, tl, tm, pos, val);
        }
        else {
            upd(vv + 1, tm + 1, tr, pos, val);
        }
        t[v] = max(t[vv], t[vv + 1]);
    }
    void upd(int p, int v){
        upd(1, 1, n, p, v);
    }
    int get(int v, int tl, int tr, int& l, int& r){
        if (l > tr || r < tl) return 0;
        if (l <= tl && tr <= r){
            return t[v];
        }
        int tm = (tl + tr) / 2, vv = 2 * v;
        return max(get(vv, tl, tm, l, r), get(vv + 1, tm + 1, tr, l, r));
    }
    int get(int l, int r){
        if (l > r || !r) return 0;
        return get(1, 1, n, l, r);
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n; ll l, r; cin>>n>>l>>r;
    vector<ll> a(n + 1);
    for (int i = 1; i <= n; i++){
        cin>>a[i];
    }
    vector<ll> x = a;
    sort(x.begin(), x.end());
    map<ll, int> mp;
    for (int i = 1; i <= n; i++) mp[x[i]] = i;
    vector<ll> :: iterator it1, it2;
    vector<int> dp(n + 1); dp[1] = 1;
    ST T(n);
    T.upd(mp[x[1]], 1);
    // dp[i] - відповідь якщо брати i-те число
    for (int i = 2; i <= n; i++){
        ll u = l - a[i], v = r - a[i];
        it1 = lower_bound(x.begin(), x.end(), u);
        it2 = upper_bound(x.begin(), x.end(), v); it2--;
        dp[i] = T.get(max(1, (int) (it1 - x.begin())), (it2 - x.begin())) + 1;
        T.upd(mp[a[i]], dp[i]);
    }
    int out = 0;
    for (int i = 1; i <= n; i++){
        out = max(out, dp[i]);
    }
    cout<<out;
}
