#include <bits/stdc++.h>
using namespace std;
using pii = pair<int, int>;
const int msz = 1e6 + 5;

struct dsu{
    vector<int> sz, p;
    int n;
    void init(int ns){
        n = ns;
        p.resize(n + 1);
        sz.resize(n + 1);
        for (int i = 1; i <= n; i++){
            p[i] = i;
            sz[i] = 1;
        }
    }
    int get(int v){
        if (p[v] != v){
            p[v] = get(p[v]);
        }
        return p[v];
    }
    void unite(int x, int y){
        x = get(x); y = get(y);
        if (x == y) return;
        if (sz[x] > sz[y]) swap(x, y);
        p[x] = y;
        sz[y] += sz[x];
    }
};

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m; cin>>n>>m;
    vector<pii> edges(m + 1);
    for (int i = 1; i <= m; i++){
        cin>>edges[i].first>>edges[i].second;
    }
    int out = 1;
    dsu T; T.init(n);
    vector<int> op(n + 1);
    for (int i = 1; i <= m; i++){
        auto [u, v] = edges[i];
        u = T.get(u); v = T.get(v);
        if (!op[u] && !op[v]){
            op[u] = v;
            op[v] = u;
        }
        if (!op[u]){
            T.unite(u, op[v]);
            op[u] = op[T.get(u)];
        }
        if (!op[v]){
            T.unite(v, op[u]);
            op[v] = op[T.get(v)];
        }
        if (T.get(u) == T.get(v)){
            out++;
            T.init(n);
            for (int j = 1; j <= n; j++){
                op[j] = 0;
            }
            i--;
        }
        // додати ребро
        // перевірити чи біпартивний
        // якщо ні, то очистити і почати з 'i'
    }
    cout<<out;
}