#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;
int q = 0;
void compres(int n, vector<int>& a, vector<int>& l, vector<int>& r, vector<ll>& cp, ll L, ll R) {
	vector<ll> otl = cp;
	sort(otl.begin(), otl.end());
	otl.resize(unique(otl.begin(), otl.end()) - otl.begin());
	q = otl.size();
	for (int i = 0; i < n; i++) {
		a[i] = lower_bound(otl.begin(), otl.end(), cp[i]) - otl.begin();
		l[i] = lower_bound(otl.begin(), otl.end(), L - cp[i]) - otl.begin();
		r[i] = upper_bound(otl.begin(), otl.end(), R - cp[i]) - otl.begin() - 1;
	}
}
vector<int> tree;
void build() {
	tree.assign(4 * q, 0);
}
void change(int nw, int ln, int rn, int pos, int val) {
	if (rn - ln == 1) {
		tree[nw] = val;
		return;
	}
	int mn = (ln + rn) / 2;
	if (pos < mn)
		change(nw * 2 + 1, ln, mn, pos, val);
	else
		change(nw * 2 + 2, mn, rn, pos, val);
	tree[nw] = max(tree[nw * 2 + 1], tree[nw * 2 + 2]);
}
void make(int pos, int val) {
	change(0, 0, q, pos, val);					//WARNING
}

int mx(int nw, int ln, int rn, int L, int R) {
	if (L <= ln && rn <= R)
		return tree[nw];
	int mn = (ln + rn) / 2;
	int ans = 0;
	if (L < mn)
		ans = max(ans, mx(nw * 2 + 1, ln, mn, L, R));
	if (mn < R)
		ans = max(ans, mx(nw * 2 + 2, mn, rn, L, R));
	return ans;
}
int max_on_range(int L, int R) {
	if (R < L)
		return 0;
	return mx(0, 0, q, L, R + 1);
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n;
	ll L, R;
	cin >> n >> L >> R;
	vector<ll> cp(n);
	for (int i = 0; i < n; i++)
		cin >> cp[i];
	vector<int> l(n), r(n), a(n);
	compres(n, a, l, r, cp, L, R);
	build();
	for (int i = 0; i < n; i++) {
		make(a[i], max_on_range(l[i], r[i]) + 1);
	}
	cout << max_on_range(0, q - 1) << "\n";
}