#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;
int n, m;
vector<int> rt;
vector<ll> ds;
void power() {
	ds.assign(n, 0ll);
	rt.resize(n);
	for (int i = 0; i < n; i++) {
		rt[i] = i;
	}
}
int get(int v) {
	int pr = rt[v];
	if (rt[v] != v)
		rt[v] = get(rt[v]);
	ds[v] = (ds[v] + ds[pr]) % 2;
	return rt[v];
}
bool we_can_do_it(int v, int w) {
	int rv = get(v);
	int rw = get(w);
	if (rv != rw)
		return true;
	return (ds[v] % 2 != ds[w] % 2);
}
void join(int v, int w) {
	int rv = get(v);
	int rw = get(w);
	if (rv == rw)
		return;
	rt[rv] = rw; //tobto rv ----> rw
	ds[rv] = (ds[v] + ds[w] + 1) % 2;
}

int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	vector<pair<int, int>> a(m);
	for (int i = 0; i < m; i++) {
		cin >> a[i].first >> a[i].second;
		a[i].first--;
		a[i].second--;
	}
	int k = 1;
	power();
	int p = 0;
	for (int i = 0; i < m; i++) {
		if (we_can_do_it(a[i].first, a[i].second)) {
			join(a[i].first, a[i].second);
		}
		else {
			for (int j = p; j <= i; j++) {
				rt[a[j].first] = a[j].first;
				rt[a[j].second] = a[j].second;
				ds[a[j].first] = 0;
				ds[a[j].second] = 0;
			}
			join(a[i].first, a[i].second);
			k++;
			p = i;
		}
	}
	cout << k << "\n";
}