#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <cmath>
#include <queue>
#include <algorithm>
using namespace std;
typedef long long ll;
typedef long double ld;

ll calc(vector<vector<ll>>& dp, vector<ll>& a, ll i, ll n, bool s, ll last, ll l, ll r) {
    if (i >= n) return 0;
    if (dp[i][s] != -1) return dp[i][s];
    ll cnt = 0;
    ll v1 = 0, v2 = 0;
    if (s) {
        if (last + a[i] >= l && last + a[i] <= r) {
            cnt++;
        }
        v1 = calc(dp, a, i + 1, n, true, a[i], l, r);
        v2 = calc(dp, a, i + 1, n, false, a[i], l, r);
    }
    else {
        v1 = calc(dp, a, i + 1, n, true, last, l, r);
        v2 = calc(dp, a, i + 1, n, false, last, l, r);
    }
    return dp[i][s] = max(v1, v2) + cnt;
}

void solve() {
    ll n, l, r; cin >> n >> l >> r;
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];
    if (n == 1) {
        cout << 1 << endl;
        return;
    }
    ll ans = 1;
    vector<vector<ll>> dp(n, vector<ll>(2, -1));
    calc(dp, a, 0, n, true, 0, l, r);
    calc(dp, a, 0, n, false, 0, l, r);
    ans = max(dp[0][0], dp[0][1]);
    cout << ans+1 << endl;
}

int main()
{
    solve();
}