#include <bits/stdc++.h>
#define int long long
using namespace std;

const int maxn = 1e5 + 10;
const long double eps = 1e-5;

int r [maxn], t [maxn];
int n, k;
vector <long double> p;

inline bool check (long double x) {
    for (int i = 0; i < n; ++i) p[i] = x * t[i] - r[i];
    sort (p.begin (), p.end ());
    long double result = 0;
    for (int i = 0; i < k; ++i) result += p[i];
    return result <= 0.0;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cout << fixed << setprecision (6);
    cin >> n >> k;
    int R = 1, T = 100000;
    for (int i = 0; i < n; ++i) cin >> r[i];
    for (int i = 0; i < n; ++i) cin >> t[i];
    for (int i = 0; i < n; ++i) if (R * t[i] < r[i] * T) T = t[i], R = r[i];
    long double tl = 0.0;
    long double tr = (1.0 * R / T);
    p.resize (n);
    while ((tr - tl) > eps) {
        long double tm = (tl + tr) / 2;
        if (check (tm)) tl = tm;
        else tr = tm;
    }
    cout << tl << '\n';
    return 0;
}
