#include <bits/stdc++.h>
//#define int long long
using namespace std;

const int maxn = 1e6 + 10;
const long double eps = 1e-5;

int a [maxn], b [maxn];
int conf [maxn], par [maxn];
vector <int> C = {};

inline int get (int x) {
    if (par[x] == x) return x;
    return par[x] = get (par[x]);
}

inline void unite (int x, int y) {
    x = get (x), y = get (y);
    if (x == y) return;
    par[x] = y;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) cin >> a[i] >> b[i], --a[i], --b[i];
    for (int i = 0; i < n; ++i) par[i] = i, conf[i] = -1;
    int result = 1;
    for (int i = 0; i < m; ++i) {
        int x = get (a[i]), y = get (b[i]);
        if (x == conf[y]) continue;
        if (x == y) {
            ++result;
            for (int j : C) conf[j] = -1, par[j] = j;
            C.clear ();
        }
        C.push_back (a[i]), C.push_back (b[i]);
        int x0 = conf[y], y0 = conf[x];
        if (x0 != -1) unite (x, x0);
        if (y0 != -1) unite (y, y0);
        conf[get (a[i])] = get (b[i]);
        conf[get (b[i])] = get (a[i]);
    }
    cout << result << '\n';
    return 0;
}
