#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <iomanip>
#include <queue>
#include <map>
#include <unordered_map>
#include <numeric>

using namespace std;

typedef long long lli;
typedef long double ld;
#define LF '\n';

vector<pair<lli, lli>> v;

bool cmp(pair<lli, lli> a, pair<lli, lli> b)
{
    return a.first * b.second > b.first * a.second;
}

void solve()
{
    lli n, k;
    cin >> n >> k;
    v.resize(n + 1);
    for (int i = 1; i <= n; i++)cin >> v[i].first;
    for (int i = 1; i <= n; i++)cin >> v[i].second;
    sort(v.begin() + 1, v.end(), cmp);
    for (int i = 2; i <= n; i++) {
        v[i].first += v[i - 1].first;
        v[i].second += v[i - 1].second;
    }
    lli x = 0, y = 1;
    for (int i = k; i <= n; i++) {
        lli tx = v[i].first - v[i - k].first;
        lli ty = v[i].second - v[i - k].second;
        if (tx * y > x * ty) {
            x = tx;
            y = ty;
        }

    }
    cout << fixed << setprecision(4) << (ld)x / (ld)y;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

