#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <iomanip>
#include <queue>
#include <map>
#include <unordered_map>
#include <numeric>

using namespace std;

typedef int lli;
#define LF '\n';

struct edge
{
    lli u1, u2;
};

struct mydsu
{
    lli dad, p;
};

vector<edge> v;
vector<vector<lli>> g;
vector<mydsu> dsu;


lli getdad(lli u)
{
    if (dsu[u].dad == u)return u;
    return dsu[u].dad = getdad(dsu[u].dad);
}

void merge(lli u1, lli u2)
{
    lli d1 = getdad(u1);
    lli d2 = getdad(u2);
    if (g[d1].size() < g[d2].size()) {
        swap(d1, d2);
        swap(u2, u1);
    }
    dsu[d2].dad = d1;
    if (dsu[u1].p == dsu[u2].p) {
        for (auto to : g[d2]) {
            dsu[to].p ^= 1;
        }
    }
    for (auto to : g[d2]) {
        g[d1].push_back(to);
    }
 //   g[d2].clear();
}

void solve()
{
    lli n, m;
    cin >> n >> m;
    v.resize(m+1);
    dsu.resize(n + 1);
    for (int i = 1; i <= n; i++)dsu[i] = { i,0 };
    for (int i = 1; i <= m; i++) cin >> v[i].u1 >> v[i].u2;
    g.resize(n + 1);
    for (int i = 1; i <= n; i++)g[i].push_back(i);
    lli ans = 1;
    for (int i = 1; i <= m; i++) {
        lli u1 = v[i].u1;
        lli u2 = v[i].u2;
        if (getdad(u1) == getdad(u2)) {
            if (dsu[u1].p == dsu[u2].p) {
                ans++;
                for (int i = 1; i <= n; i++)dsu[i] = { i,0 };
                for (int i = 1; i <= n; i++) {
                    g[i].clear();
                    g[i].push_back(i);
                }
                merge(u1, u2);
            }
        }
        else {
            merge(u1, u2);
        }
    }
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    solve();
}

