def counter(q):
    x_c = z_c = 0
    for i in q:
        x_c += i.count('X')
        z_c += i.count('0')
    return (x_c, z_c)


def brain(a, b):
    a_x, a_z = counter(a)
    b_x, b_z = counter(b)
    if a_x == a_z and b_x < b_z:
        return 'no'
    if b_x > b_z + 1:
        return 'no'
    if a_x > b_x:
        return 'no'
    if a_z > b_z:
        return 'no'

    for i in range(3):
        for j in range(3):
            if (a[i][j] == 'X' and b[i][j] != 'X') or (a[i][j] == '0' and b[i][j] != '0'):
                return 'no'


a0 = [input() for __ in range(3)]
b0 = [input() for _ in range(3)]
print(brain(a0, b0).upper())
