#include <algorithm>
#include <climits>
#include <iomanip>
#include <iostream>
#include <map>
#include <set>
#include <vector>

using namespace std;

#define ll long long
#define lf long double
#define ull unsigned long long
#define ul unsigned long
#define all(vec) vec.begin(), vec.end()
#define rall(vec) vec.rbegin(), vec.rend()
#define nl "\n"

int main() {
  ll n, m, k;
  ll a, b, c, d, e, f, g, o, p, x, y, l, r;
  bool bl;
  char ch;
  string str;
  cin >> n >> l >> r;
  vector<ll> vec(n);
  vector<pair<ll, ll>> segments;
  segments.push_back({0, 0});
  ll answer = 1;
  for (ll i = 0; i < n; i++) {
    cin >> vec[i];
    a = 0;
    if (i < r) {
      for (auto j : segments) {
        if (l <= j.first + vec[i] && j.first + vec[i] <= r) {
          a = max(a, j.second);
          break;
        }
      }
    }
    answer = max(answer, a + 1);
    auto it = lower_bound(all(segments), pair<ll, ll>{a + 1, vec[i]},
                          [](pair<ll, ll> first, pair<ll, ll> second) {
                            return first.second > second.second;
                          });
    segments.insert(it, {vec[i], a + 1});
  }
  cout << answer;
}
